
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>


#include "SDL/SDL.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include "gameengine.h"
#include "../nivo/gamestate.h"



const int          CLIP_PRVI_BALVAN = 0;
const int          CLIP_DRUGI_BALVAN = 1;
const int          CLIP_TRECI_BALVAN = 2;
const int          CLIP_CETVRTI_BALVAN = 3;
const int          CLIP_PETI_BALVAN = 4;
const int          CLIP_SESTI_BALVAN = 5;
const int          CLIP_SEDMI_BALVAN = 6;
const int          CLIP_OSMI_BALVAN = 7;
const int          CLIP_DEVETI_BALVAN = 8;
const int          CLIP_DESETI_BALVAN = 9;


int cGameEngine::Init(const char* title, int width, int height,
						 int bpp, bool fullscr)
{
	int flags = 0;

	SDL_Init(SDL_INIT_VIDEO);

	//SDL_EnableUNICODE( SDL_ENABLE );

	SDL_WM_SetCaption(title, title);

	g_Ekran = SDL_SetVideoMode(width, height, bpp, flags);

    //AudioInit();

    //ImgInit();
    resourceman.Init();

	g_Radi = true;
    g_PrikaziPoruku = false;

    g_LevoDugmePritisnuto = false;
    g_KrajIgre  = false;

    ClipoviZaBalvane();

    g_TempBalvan  = NULL;
    g_TempBalvanS = NULL;

    g_CeoEkran = false;

	printf("cGameEngine Init\n");

	return 0;
}

void cGameEngine::Cleanup()
{

	while ( !m_Stanja.empty() ) {
		m_Stanja.top()->Cleanup(this);
		m_Stanja.pop();
	}

	printf("cGameEngine Cleanup\n");

	//AudioExit();
	//ImgExit();
	resourceman.Cleanup();

	SDL_Quit();
}

void cGameEngine::ChangeState(cGameState* state)
{
	// cleanup the current state
	if ( !m_Stanja.empty() ) {
		m_Stanja.top()->Cleanup(this);
		m_Stanja.pop();
	}

	// store and init the new state
	m_Stanja.push(state);
	m_Stanja.top()->Init(this);
}

void cGameEngine::PushState(cGameState* state)
{
	// pause current state
	if ( !m_Stanja.empty() ) {
		m_Stanja.top()->Pause();
	}

	// store and init the new state
	m_Stanja.push(state);
	m_Stanja.top()->Init(this);
}

void cGameEngine::PopState()
{
	// cleanup the current state
	if ( !m_Stanja.empty() ) {
		m_Stanja.top()->Cleanup(this);
		//delete this;
		m_Stanja.pop();
	}

	// resume previous state
	if ( !m_Stanja.empty() ) {
		m_Stanja.top()->Resume();
	}
}

void cGameEngine::HandleEvents()
{
	// let the state handle events
	m_Stanja.top()->HandleEvents(this);
}

void cGameEngine::Update()
{
	// let the state update the game
	m_Stanja.top()->Update(this);
}

void cGameEngine::Draw()
{
	// let the state draw the g_Ekran
	m_Stanja.top()->Draw(this);
}

void cGameEngine::CrtajSliku( int x, int y, SDL_Surface* source, SDL_Surface* destination)
{
    SDL_Rect offset;

    offset.x = x;
    offset.y = y;

    SDL_BlitSurface( source, NULL, destination, &offset );
}

void cGameEngine::ClipoviZaBalvane()
{
    g_ClipoviZaBalvane[ CLIP_PRVI_BALVAN ].x = 0;
    g_ClipoviZaBalvane[ CLIP_PRVI_BALVAN ].y = 0;
    g_ClipoviZaBalvane[ CLIP_PRVI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_PRVI_BALVAN ].h = 195;

    g_ClipoviZaBalvane[ CLIP_DRUGI_BALVAN ].x = 28;
    g_ClipoviZaBalvane[ CLIP_DRUGI_BALVAN ].y = 19;
    g_ClipoviZaBalvane[ CLIP_DRUGI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_DRUGI_BALVAN ].h = 175;

    g_ClipoviZaBalvane[ CLIP_TRECI_BALVAN ].x = 56;
    g_ClipoviZaBalvane[ CLIP_TRECI_BALVAN ].y = 34;
    g_ClipoviZaBalvane[ CLIP_TRECI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_TRECI_BALVAN ].h = 160;

    g_ClipoviZaBalvane[ CLIP_CETVRTI_BALVAN ].x = 83;
    g_ClipoviZaBalvane[ CLIP_CETVRTI_BALVAN ].y = 51;
    g_ClipoviZaBalvane[ CLIP_CETVRTI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_CETVRTI_BALVAN ].h = 144;

    g_ClipoviZaBalvane[ CLIP_PETI_BALVAN ].x = 112;
    g_ClipoviZaBalvane[ CLIP_PETI_BALVAN ].y = 68;
    g_ClipoviZaBalvane[ CLIP_PETI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_PETI_BALVAN ].h = 130;

    g_ClipoviZaBalvane[ CLIP_SESTI_BALVAN ].x = 140;
    g_ClipoviZaBalvane[ CLIP_SESTI_BALVAN ].y = 84;
    g_ClipoviZaBalvane[ CLIP_SESTI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_SESTI_BALVAN ].h = 112;

    g_ClipoviZaBalvane[ CLIP_SEDMI_BALVAN ].x = 170;
    g_ClipoviZaBalvane[ CLIP_SEDMI_BALVAN ].y = 99;
    g_ClipoviZaBalvane[ CLIP_SEDMI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_SEDMI_BALVAN ].h = 96;

    g_ClipoviZaBalvane[ CLIP_OSMI_BALVAN ].x = 199;
    g_ClipoviZaBalvane[ CLIP_OSMI_BALVAN ].y = 117;
    g_ClipoviZaBalvane[ CLIP_OSMI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_OSMI_BALVAN ].h = 80;

    g_ClipoviZaBalvane[ CLIP_DEVETI_BALVAN ].x = 227;
    g_ClipoviZaBalvane[ CLIP_DEVETI_BALVAN ].y = 133;
    g_ClipoviZaBalvane[ CLIP_DEVETI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_DEVETI_BALVAN ].h = 63;

    g_ClipoviZaBalvane[ CLIP_DESETI_BALVAN ].x = 255;
    g_ClipoviZaBalvane[ CLIP_DESETI_BALVAN ].y = 148;
    g_ClipoviZaBalvane[ CLIP_DESETI_BALVAN ].w = 29;
    g_ClipoviZaBalvane[ CLIP_DESETI_BALVAN ].h = 48;
}



bool cGameEngine::ProveriKoliziju( SDL_Rect A, SDL_Rect B )
{
    //stranice pravougaonika
    int leftA, leftB;
    int rightA, rightB;
    int topA, topB;
    int bottomA, bottomB;

    //izracunaj stranice prav. A
    leftA = A.x;
    rightA = A.x + A.w;
    topA = A.y;
    bottomA = A.y + A.h;

    //izracunaj stranice prav. B
    leftB = B.x;
    rightB = B.x + B.w;
    topB = B.y;
    bottomB = B.y + B.h;

    //ako je bilo koja stranica A van stranice B
    if( bottomA <= topB )
    {
        return false;
    }

    if( topA >= bottomB )
    {
        return false;
    }

    if( rightA <= leftB )
    {
        return false;
    }

    if( leftA >= rightB )
    {
        return false;
    }

    //ako nijedna stranica A nije van B
    return true;
}


