
#ifndef GAMEENGINE_H
#define GAMEENGINE_H

#include "SDL/SDL.h"
#include "SDL/SDL_mixer.h"
#include "../gui/balvan.h"
#include "../gui/cvet_meta.h"
#include "resourcemanager.h"
#include <iostream>
#include <vector>
#include <stack>

using namespace std;

class cGameState;

class cBalvan;

class cCvetMeta;

class cGameEngine
{
public:

	int Init(const char* title, int width=640, int height=480,
		      int bpp=0, bool fullScreen=false);
	void Cleanup();

	void ChangeState(cGameState* state);
	void PushState(cGameState* state);
	void PopState();

	void HandleEvents();
	void Update();
	void Draw();

	bool Running() { return g_Radi; }
	void Quit() { g_Radi = false; }

	SDL_Surface   *g_Ekran;

	void          CrtajSliku( int, int, SDL_Surface*, SDL_Surface* );
	void          ClipoviZaBalvane();
	bool          ProveriKoliziju(SDL_Rect,SDL_Rect);

	cResourceManager UzmiMediju()
	{
	    return resourceman;
    };
	
    bool g_PrikaziPoruku;
    int  g_Frejm;
    int  g_BrojKolizija;
    bool g_KrajIgre;
    bool g_LevoDugmePritisnuto;
    bool g_CeoEkran;

    vector<cCvetMeta*>    g_VektorCvetova;
    vector<cBalvan*>      g_VektorBalvana;
    vector<int>           g_VektorPoretka;

    cBalvan*              g_TempBalvan;
    cBalvan*              g_TempBalvanS;
    SDL_Rect              g_ClipoviZaBalvane[ 10 ];

private:
	// stek stanja
    stack<cGameState*> m_Stanja;

    cResourceManager       resourceman;

	bool g_Radi;
};



#endif /* GAMEENGINE_H */
