
#include "balvan.h"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>



cBalvan::cBalvan(){}

void cBalvan::Init( int x, int y, int w, int h, int r_br ,cGameEngine *game)
{
    m_Kutija.w = w;
    m_Kutija.h = h;
    m_Kutija.x = x;
    m_Kutija.y = y;

    m_Koord_x = x;
    m_Koord_y = y;

    m_Sprajtovi = game->UzmiMediju().r_StapiciBitmap;

    m_RedniBroj = r_br;

    m_Mrtav = false;
}

cBalvan::~cBalvan()
{
}

void cBalvan::RukovanjeSignalima(SDL_Event event ,cGameEngine* game)
{

int x = 0, y = 0;

if (!game->g_KrajIgre)
 {

    if( event.type == SDL_MOUSEBUTTONDOWN )
    {
        if( event.button.button == SDL_BUTTON_LEFT )
        {

            x = event.button.x;
            y = event.button.y;

            game->g_LevoDugmePritisnuto = true;
            for (int i = 0;i < 10;i++)
            {
                    SDL_Rect& box = game->g_VektorBalvana[i]->UzmiKutiju();
                    if( ( x > box.x ) && ( x < box.x + box.w ) && ( y > box.y ) && ( y < box.y + box.h ) )
                        {
                            game->g_TempBalvan = game->g_VektorBalvana[i];
                        }
            }
        }

        if( event.button.button == SDL_BUTTON_RIGHT )
        {
            x = event.button.x;
            y = event.button.y;

            for (int i = 0;i < 10;i++)
            {
                    SDL_Rect& box = game->g_VektorBalvana[i]->UzmiKutiju();
                    if ( game->g_VektorBalvana[i]->DalJeMrtav() )
                    {
                    if( ( x > box.x ) && ( x < box.x + box.w ) && ( y > box.y ) && ( y < box.y + box.h ) )
                        {
                            //vrati balvan na pocetno mesto
                            game->g_VektorBalvana[i]->PostaviNaPocetak();
                            //reaktiviraj cvet sa rednim brojem tim i tim
                            game->g_VektorCvetova[game->g_VektorBalvana[i]->VratiRedniBrCveta()]->Reaktiviraj();
                            game->g_BrojKolizija--;
                        }
                    }
            }
        }

    }

    if( event.type == SDL_MOUSEBUTTONUP )
    {

        if( event.button.button == SDL_BUTTON_LEFT )
        {
              if (game->g_TempBalvan != NULL)
              {
                game->g_LevoDugmePritisnuto = false;
                game->g_TempBalvan = NULL;
              }
        }
    }

    if( event.type == SDL_MOUSEMOTION && game->g_LevoDugmePritisnuto)
    {
        x = event.motion.x;
        y = event.motion.y;

        if (game->g_TempBalvan != NULL)
        {
                SDL_Rect& box = game->g_TempBalvan->UzmiKutiju();
                if ( !game->g_TempBalvan->DalJeMrtav() )
                {
                box.x = x - ( game->g_TempBalvan->UzmiSirinuSprajta() / 2);
                box.y = y - ( game->g_TempBalvan->UzmiVisinuSprajta() / 2);
                }
        }
     }
 }
}


void cBalvan::Prikazi(SDL_Surface* ekran)
{
    SDL_Rect offset;

    offset.x = m_Kutija.x;
    offset.y = m_Kutija.y;

	SDL_BlitSurface(m_Sprajtovi, m_Klip, ekran, &offset);
}

void cBalvan::PostaviIme(string ime)
{
    m_Ime = ime;
}

string cBalvan::StampajIme()
{
    return m_Ime;
}

void cBalvan::PostaviSprajt(SDL_Rect* klip)
{
    m_Klip = klip;
}

SDL_Rect &cBalvan::UzmiKutiju()
{
    return m_Kutija;
}

void cBalvan::PostaviRedniBr(int br)
{
    m_RedniBroj = br;
}

int cBalvan::UzmiSirinuSprajta()
{
    return m_Klip->w;
}

int cBalvan::UzmiVisinuSprajta()
{
    return m_Klip->h;
}

SDL_Rect* cBalvan::UzmiSprajt()
{
    return m_Klip;
}

cBalvan::operator SDL_Rect()
{
    return m_Kutija;
}

int cBalvan::VratiRedniBroj()
{
    return m_RedniBroj;
}

void cBalvan::Deaktiviraj()
{
    m_Mrtav = true;
}

void cBalvan::PostaviDimKutije(int w,int h)
{
    m_Kutija.w = w;
    m_Kutija.h = h;
}

void cBalvan::PostaviNaPoziciju(int x,int y)
{
    m_Kutija.x = x;
    m_Kutija.y = y;
}

void cBalvan::PostaviNaPocetak()
{
    m_Kutija.x = m_Koord_x;
    m_Kutija.y = m_Koord_y;

    m_Mrtav = false;
}

void cBalvan::UzmiRedniBrCveta(int rbr)
{
    m_RedniBrojCveta = rbr;
}

int cBalvan::VratiRedniBrCveta()
{
    return m_RedniBrojCveta;
}
