#include <iostream>
#include "cvet_meta.h"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


cCvetMeta::cCvetMeta(){}

cCvetMeta::cCvetMeta( int x, int y, int r_br,cGameEngine *game)
{
    m_Kutija.w = 3;
    m_Kutija.h = 3;

    m_Kutija.x = x;
    m_Kutija.y = y;

    m_CvetBitmap = game->UzmiMediju().r_CvetBitmap;
    m_RedniBroj = r_br;

    m_Mrtav  = false;
}

cCvetMeta::~cCvetMeta()
{
    //SDL_FreeSurface( m_CvetBitmap );
}

void cCvetMeta::Prikazi(SDL_Surface* ekran, bool prikazi_me)
{
    if ( prikazi_me == true)
    {
        SDL_Rect offset;

        offset.x = m_Kutija.x;
        offset.y = m_Kutija.y;

        SDL_BlitSurface(m_CvetBitmap, NULL, ekran, &offset);
    }
}

cCvetMeta::operator SDL_Rect()
{
    return m_Kutija;
}

SDL_Rect &cCvetMeta::UzmiKutiju()
{
    return m_Kutija;
}

void cCvetMeta::Obrisi()
{
    delete this;
}

int cCvetMeta::VratiRedniBroj()
{
    return m_RedniBroj;
}


void cCvetMeta::Deaktiviraj()
{
    m_Kutija.w = 0;
    m_Kutija.h = 0;

    m_Mrtav = true;
}

bool cCvetMeta::DalJeMrtav()
{
    return m_Mrtav;
}

int cCvetMeta::UzmiKoordX()
{
    return m_Kutija.x;
}

int cCvetMeta::UzmiKoordY()
{
    return m_Kutija.y;
}

void cCvetMeta::Reaktiviraj()
{
    m_Kutija.w = 3;
    m_Kutija.h = 3;

    m_Mrtav = false;
}


