
#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "dugme.h"
#include <iostream>
#include "../nivo/izbor.h"

const int CLIP_MISHIZNAD = 0;
const int CLIP_MISHIZVAN = 1;
const int CLIP_MISHDOLE = 2;

using namespace std;

cDugme::cDugme(int x, int y, int w, int h,string ime,cGameEngine *game)
{
    m_Box.x = x;
    m_Box.y = y;
    m_Box.w = w;
    m_Box.h = h;

    m_Ime = ime;

    m_DugmeBitmap  = game->UzmiMediju().r_DugmeStart;

	printf("cDugme Init\n");

	m_Clipovi_dugme_start[ CLIP_MISHIZVAN ].x = 0;
    m_Clipovi_dugme_start[ CLIP_MISHIZVAN ].y = 0;
    m_Clipovi_dugme_start[ CLIP_MISHIZVAN ].w = 215;
    m_Clipovi_dugme_start[ CLIP_MISHIZVAN ].h = 102;

    m_Clipovi_dugme_start[ CLIP_MISHIZNAD ].x = 215;
    m_Clipovi_dugme_start[ CLIP_MISHIZNAD ].y = 0;
    m_Clipovi_dugme_start[ CLIP_MISHIZNAD ].w = 215;
    m_Clipovi_dugme_start[ CLIP_MISHIZNAD ].h = 102;

    m_Clipovi_dugme_start[ CLIP_MISHDOLE ].x = 430;
    m_Clipovi_dugme_start[ CLIP_MISHDOLE ].y = 0;
    m_Clipovi_dugme_start[ CLIP_MISHDOLE ].w = 215;
    m_Clipovi_dugme_start[ CLIP_MISHDOLE ].h = 102;

	//postavi prvi status
	m_Clip = &m_Clipovi_dugme_start[ CLIP_MISHIZVAN ];

	m_Pritisnuto = false;
}

void cDugme::HandleEvents(SDL_Event event, cGameEngine* game)
{

	int x = 0, y = 0;


    if( event.type == SDL_MOUSEMOTION )
    {

        x = event.motion.x;
        y = event.motion.y;

        if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
        {

            m_Clip = &m_Clipovi_dugme_start[ CLIP_MISHIZNAD ];
        }
        else
        {
            m_Clip = &m_Clipovi_dugme_start[ CLIP_MISHIZVAN ];
            m_Pritisnuto= false;
        }
        if (( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) && m_Pritisnuto)
        {
            m_Clip = &m_Clipovi_dugme_start[ CLIP_MISHDOLE ];
        }
    }

    if( event.type == SDL_MOUSEBUTTONDOWN )
    {

        if( event.button.button == SDL_BUTTON_LEFT )
        {

            x = event.button.x;
            y = event.button.y;

            if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
            {
                m_Clip = &m_Clipovi_dugme_start[ CLIP_MISHDOLE ];
                m_Pritisnuto= true;
            }
        }
    }

    if( event.type == SDL_MOUSEBUTTONUP )
    {
        if( event.button.button == SDL_BUTTON_LEFT )
        {

            x = event.button.x;
            y = event.button.y;

            if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
            {
                game->ChangeState( cIzbor::Instance() );
                m_Pritisnuto= false;
                m_Clip = &m_Clipovi_dugme_start[ CLIP_MISHIZNAD ];
                Mix_PlayChannel( -1, game->UzmiMediju().r_Klik, 0 );
            }
        }
    }

}

cDugme::~cDugme()
{
}

void cDugme::Draw(SDL_Surface* ekran)
{
	SDL_Rect offset;

    offset.x = m_Box.x;
    offset.y = m_Box.y;

	SDL_BlitSurface(m_DugmeBitmap, m_Clip, ekran, &offset);
}

string cDugme::UzmiIme()
{
    return m_Ime;
}

void cDugme::Obrisi()
{
    delete this;
}
