

#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "dugme_izbor.h"
#include <iostream>
#include "../nivo/serijacija.h"

const int CLIP_MISHIZVAN = 0;
const int CLIP_MISHIZNAD = 1;
const int CLIP_MISHDOLE = 2;

using namespace std;

cDugmeIzbor::cDugmeIzbor(int x, int y, int w, int h,cGameEngine *game)
{
    m_Box.x = x;
    m_Box.y = y;
    m_Box.w = w;
    m_Box.h = h;

    m_DugmeIzborBitmap = game->UzmiMediju().r_DugmeIzbor;

	m_Clipovi_dugme_izbor[ CLIP_MISHIZVAN ].x = 0;
    m_Clipovi_dugme_izbor[ CLIP_MISHIZVAN ].y = 0;
    m_Clipovi_dugme_izbor[ CLIP_MISHIZVAN ].w = 47;
    m_Clipovi_dugme_izbor[ CLIP_MISHIZVAN ].h = 37;

    m_Clipovi_dugme_izbor[ CLIP_MISHIZNAD ].x = 47;
    m_Clipovi_dugme_izbor[ CLIP_MISHIZNAD ].y = 0;
    m_Clipovi_dugme_izbor[ CLIP_MISHIZNAD ].w = 47;
    m_Clipovi_dugme_izbor[ CLIP_MISHIZNAD ].h = 37;

    m_Clipovi_dugme_izbor[ CLIP_MISHDOLE ].x = 94;
    m_Clipovi_dugme_izbor[ CLIP_MISHDOLE ].y = 0;
    m_Clipovi_dugme_izbor[ CLIP_MISHDOLE ].w = 47;
    m_Clipovi_dugme_izbor[ CLIP_MISHDOLE ].h = 37;

	//postavi prvi status
	m_Clip = &m_Clipovi_dugme_izbor[ CLIP_MISHIZVAN ];

	m_Pritisnuto = false;
}

void cDugmeIzbor::HandleEvents(SDL_Event event, cGameEngine* game)
{

	int x = 0, y = 0;


    if( event.type == SDL_MOUSEMOTION )
    {

        x = event.motion.x;
        y = event.motion.y;

        if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
        {

            m_Clip = &m_Clipovi_dugme_izbor[ CLIP_MISHIZNAD ];
            game->g_PrikaziPoruku = true;
        }
        else
        {
            m_Clip = &m_Clipovi_dugme_izbor[ CLIP_MISHIZVAN ];
            m_Pritisnuto = false;
            game->g_PrikaziPoruku = false;
        }
        if (( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) && m_Pritisnuto)
        {
            m_Clip = &m_Clipovi_dugme_izbor[ CLIP_MISHDOLE ];
        }
    }

    if( event.type == SDL_MOUSEBUTTONDOWN )
    {

        if( event.button.button == SDL_BUTTON_LEFT )
        {

            x = event.button.x;
            y = event.button.y;

            if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
            {
                m_Pritisnuto = true;
                m_Clip = &m_Clipovi_dugme_izbor[ CLIP_MISHDOLE ];
            }
        }
    }

    if( event.type == SDL_MOUSEBUTTONUP )
    {
        if( event.button.button == SDL_BUTTON_LEFT )
        {

            x = event.button.x;
            y = event.button.y;

            if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
            {
                game->ChangeState( cSerijacija::Instance() );
                m_Pritisnuto = false;
                m_Clip = &m_Clipovi_dugme_izbor[ CLIP_MISHIZNAD ];
                Mix_PlayChannel( -1, game->UzmiMediju().r_Klik, 0 );
            }
        }
    }
}

cDugmeIzbor::~cDugmeIzbor()
{
}

void cDugmeIzbor::Draw(SDL_Surface* ekran)
{
	SDL_Rect offset;

    offset.x = m_Box.x;
    offset.y = m_Box.y;

	SDL_BlitSurface(m_DugmeIzborBitmap, m_Clip, ekran, &offset);;
}



