
#include <stdlib.h>
#include <iostream>
#include "../nivo/gamestate.h"
#include "../nivo/izbor.h"
#include <SDL/SDL_image.h>
#include "dugme_izlaz.h"


const int CLIP_MISHIZNAD = 0;
const int CLIP_MISHIZVAN = 1;
const int CLIP_MISHDOLE = 2;

cDugmeIzlaz::cDugmeIzlaz(int x, int y, int w, int h, cGameEngine *game)
{
    m_Box.x = x;
    m_Box.y = y;
    m_Box.w = w;
    m_Box.h = h;

    m_DugmeIzlazBitmap = game->UzmiMediju().r_DugmeIzlaz;

    m_Clipovi_dugme_izlaz[ CLIP_MISHIZVAN ].x = 0;
    m_Clipovi_dugme_izlaz[ CLIP_MISHIZVAN ].y = 0;
    m_Clipovi_dugme_izlaz[ CLIP_MISHIZVAN ].w = 89;
    m_Clipovi_dugme_izlaz[ CLIP_MISHIZVAN ].h = 75;

    m_Clipovi_dugme_izlaz[ CLIP_MISHIZNAD ].x = 89;
    m_Clipovi_dugme_izlaz[ CLIP_MISHIZNAD ].y = 0;
    m_Clipovi_dugme_izlaz[ CLIP_MISHIZNAD ].w = 89;
    m_Clipovi_dugme_izlaz[ CLIP_MISHIZNAD ].h = 75;

    m_Clipovi_dugme_izlaz[ CLIP_MISHDOLE ].x = 178;
    m_Clipovi_dugme_izlaz[ CLIP_MISHDOLE ].y = 0;
    m_Clipovi_dugme_izlaz[ CLIP_MISHDOLE ].w = 89;
    m_Clipovi_dugme_izlaz[ CLIP_MISHDOLE ].h = 75;

    m_Clip = &m_Clipovi_dugme_izlaz[ CLIP_MISHIZVAN ];

    m_Pritisnuto = false;
}

cDugmeIzlaz::~cDugmeIzlaz()
{
}

void cDugmeIzlaz::HandleEvents(SDL_Event event, cGameEngine* game)
{
    int x = 0, y = 0;

    if( event.type == SDL_MOUSEBUTTONDOWN )
    {

        if( event.button.button == SDL_BUTTON_LEFT )
        {
            x = event.button.x;
            y = event.button.y;

            m_Pritisnuto = true;

            if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
            {

                m_Clip = &m_Clipovi_dugme_izlaz[ CLIP_MISHDOLE ];
                m_Pritisnuto = true;
            }
        }
    }

    if( event.type == SDL_MOUSEBUTTONUP )
    {
        if( event.button.button == SDL_BUTTON_LEFT )
        {
            x = event.button.x;
            y = event.button.y;

            m_Pritisnuto = false;

            if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
            {

                m_Clip = &m_Clipovi_dugme_izlaz[ CLIP_MISHIZNAD ];
                Mix_PlayChannel( -1, game->UzmiMediju().r_Klik, 0 );
                game->ChangeState( cIzbor::Instance() );
            }
        }
    }

    if( event.type == SDL_MOUSEMOTION )
    {
        x = event.motion.x;
        y = event.motion.y;

        if( ( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) )
        {
            //SDL_ShowCursor(SDL_ENABLE);
            m_Clip = &m_Clipovi_dugme_izlaz[ CLIP_MISHIZNAD ];
        }
        else
        {
            //SDL_ShowCursor(SDL_DISABLE);
            m_Clip = &m_Clipovi_dugme_izlaz[ CLIP_MISHIZVAN ];
            m_Pritisnuto = false;
        }
        if (( x > m_Box.x ) && ( x < m_Box.x + m_Box.w ) && ( y > m_Box.y ) && ( y < m_Box.y + m_Box.h ) && m_Pritisnuto)
        {
            m_Clip = &m_Clipovi_dugme_izlaz[ CLIP_MISHDOLE ];
        }
    }

}

void cDugmeIzlaz::Draw(SDL_Surface* ekran)
{
    SDL_Rect offset;

    offset.x = m_Box.x;
    offset.y = m_Box.y;

	SDL_BlitSurface(m_DugmeIzlazBitmap, m_Clip, ekran, &offset);
}
