#include "font27.h"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


cFont27::cFont27(cGameEngine *game)
{
	m_pFontList = SDL_DisplayFormatAlpha(game->UzmiMediju().r_Font27);
	m_Text = "";
    m_Index = 0;
}

cFont27::~cFont27(void)
{
    //SDL_FreeSurface(m_pFontList);
}

int cFont27::Prikazi(std::string text, int type, int pos_x, int pos_y, SDL_Surface* pScreen)
{

	if(!pScreen) return 1;

	SDL_Rect rect, src_rect; 
	rect.x = pos_x;
	rect.y = pos_y;
	SDL_Rect tmp_rect;
	tmp_rect.y = 0*type;

	for(int i=0; i < text.size(); i++) {

		tmp_rect.y = 0; 

		switch(text[i]) {
			case 0x20:
				rect.x += 10;
				break;
            case 0x7B: // { = SH veliko
				tmp_rect.x = 910;
				tmp_rect.w = 26;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x7D: // } = DJ veliko
				tmp_rect.x = 372;
				tmp_rect.w = 22;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x27: // ' = tj malo
				tmp_rect.x = 730;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x40: // @ = TJ veliko
				tmp_rect.x = 882;
				tmp_rect.w = 22;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

            case 0x23: // # = zh malo
				tmp_rect.x = 2130;
				tmp_rect.w = 24;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

            case 0x7E: // ~ = ZH veliko
				tmp_rect.x = 1382;
				tmp_rect.w = 30;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x21: // !
				tmp_rect.x = 1532;
				tmp_rect.w = 10;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x2D: // -
				tmp_rect.x = 2290;
				tmp_rect.w = 14;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x30: // 0
				tmp_rect.x = 628;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x31: // 1
				tmp_rect.x = 1491;
				tmp_rect.w = 13;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x32: // 2
				tmp_rect.x = 1466;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x33: // 3
				tmp_rect.x = 604;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x34: // 4
				tmp_rect.x = 1442;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x35: // 5
				tmp_rect.x = 1420;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x36: // 6
				tmp_rect.x = 582;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x37: // 7
				tmp_rect.x = 1560;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x38: // 8
				tmp_rect.x = 558;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x39: // 9
				tmp_rect.x = 536;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3A: // : = CH veliko
				tmp_rect.x = 856;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3B: // ;  = ch malo
				tmp_rect.x = 1834;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3C: // <
				tmp_rect.x = 1810;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3D: // =
				tmp_rect.x = 2200;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3E: // >
				tmp_rect.x = 1786;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3F: // ?
				tmp_rect.x = 512;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x41: // A
				tmp_rect.x = 1535;
				tmp_rect.w = 22;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x42: // B
				tmp_rect.x = 1324;
				tmp_rect.w = 21;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x43: // C
				tmp_rect.x = 128;
				tmp_rect.w = 23;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x44: // D
				tmp_rect.x = 100;
				tmp_rect.w = 23;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x45: // E
				tmp_rect.x = 1300;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x46: // F
				tmp_rect.x = 1269;
				tmp_rect.w = 24;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x47: // G
				tmp_rect.x = 1245;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x48: // H
				tmp_rect.x = 1219;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x49: // I
				tmp_rect.x = 1191;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4A: // J
				tmp_rect.x = 491;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4B: // K
				tmp_rect.x = 1163;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4C: // L
				tmp_rect.x = 464;
				tmp_rect.w = 21;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4D: // M
				tmp_rect.x = 1134;
				tmp_rect.w = 23;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4E: // N
				tmp_rect.x = 1108;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4F: // O
				tmp_rect.x = 270;
				tmp_rect.w = 23;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x50: // P
				tmp_rect.x = 1082;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x51: // Q = LJ veliko
				tmp_rect.x = 428;
				tmp_rect.w = 30;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x52: // R
				tmp_rect.x = 1057;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x53: // S
				tmp_rect.x = 242;
				tmp_rect.w = 21;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x54: // T
				tmp_rect.x = 1031;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x55: // U
				tmp_rect.x = 401;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x56: // V
				tmp_rect.x = 1005;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x57: // W = NJ veliko
				tmp_rect.x = 971;
				tmp_rect.w = 28;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x58: // X = DZ veliko
				tmp_rect.x = 43;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x59: // Y = Z veliko
				tmp_rect.x = 217;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x5B: // [ sh malo
				tmp_rect.x = 1857;
				tmp_rect.w = 22;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x5C: // /
				tmp_rect.x = 652;
				tmp_rect.w = 12;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x5D: // ] = dj malo
				tmp_rect.x = 4;
				tmp_rect.w = 16;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x61: // a
				tmp_rect.x = 1763;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x62: // b
				tmp_rect.x = 347;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x63: // c
				tmp_rect.x = 832;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x64: // d
				tmp_rect.x = 805;
				tmp_rect.w = 21;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x65: // e
				tmp_rect.x = 1739;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x66: // f
				tmp_rect.x = 69;
				tmp_rect.w = 24;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x67: // g
				tmp_rect.x = 2108;
				tmp_rect.w = 13;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x68: // h
				tmp_rect.x = 2084;
				tmp_rect.w = 16;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x69: // i
				tmp_rect.x = 2059;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6A: // j
				tmp_rect.x = 27;
				tmp_rect.w = 10;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6B: // k
				tmp_rect.x = 2034;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6C: // l
				tmp_rect.x = 1713;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6D: // m
				tmp_rect.x = 2008;
				tmp_rect.w = 20;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6E: // n
				tmp_rect.x = 1985;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6F: // o
				tmp_rect.x = 1688;
				tmp_rect.w = 19;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x70: // p
				tmp_rect.x = 1962;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x71: // q = lj malo
				tmp_rect.x = 1655;
				tmp_rect.w = 26;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x72: // r
				tmp_rect.x = 780;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x73: // s
				tmp_rect.x = 1632;
				tmp_rect.w = 16;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x74: // t
				tmp_rect.x = 1940;
				tmp_rect.w = 16;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x75: // u
				tmp_rect.x = 756;
				tmp_rect.w = 18;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x76: // v
				tmp_rect.x = 1917;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x77: // w  = nj malo
				tmp_rect.x = 1886;
				tmp_rect.w = 25;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x78: // x = dz malo
				tmp_rect.x = 299;
				tmp_rect.w = 17;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x79: // y = z malo
				tmp_rect.x = 1610;
				tmp_rect.w = 16;
				tmp_rect.h = 40;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
		}

	}

	return 0;
}

void cFont27::PrikaziPostepeno(std::string e_text,int p_x,int p_y,SDL_Surface* pScreen,int type,int frame)
{
  pos_x = p_x;pos_y=p_y;

  if ( frame % 2 == 0 )
   {
    if ( m_Index < e_text.size() )
     {
          m_Text += e_text[m_Index];
          m_Index++;
     }
   }
   Prikazi(m_Text, type, pos_x, pos_y,pScreen);

}
