#include "font52.h"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


cFont52::cFont52(cGameEngine *game)
{
	m_pFontList = SDL_DisplayFormatAlpha(game->UzmiMediju().r_Font52);
	m_Text = "";
    m_Index = 0;
}

cFont52::~cFont52(void)
{
    //SDL_FreeSurface(m_pFontList);
}

int cFont52::Prikazi(std::string text, int type, int pos_x, int pos_y, SDL_Surface* pScreen)
{
	if(!pScreen) return 1;

	SDL_Rect rect, src_rect; 
	rect.x = pos_x;
	rect.y = pos_y;
	SDL_Rect tmp_rect;
	tmp_rect.y = 0*type;

	for(int i=0; i < text.size(); i++) {

		tmp_rect.y = 0; 

		switch(text[i]) {
			case 0x20:
				rect.x += 10;
				break;
            case 0x7B: // { = SH veliko
				tmp_rect.x = 1074;
				tmp_rect.w = 45;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x7D: // } = DJ veliko
				tmp_rect.x = 1028;
				tmp_rect.w = 37;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x27: // ' = tj malo
				tmp_rect.x = 781;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x40: // @ = TJ veliko
				tmp_rect.x = 982;
				tmp_rect.w = 37;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

            case 0x23: // # = zh malo
				tmp_rect.x = 3425;
				tmp_rect.w = 44;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

            case 0x7E: // ~ = ZH veliko
				tmp_rect.x = 1947;
				tmp_rect.w = 52;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x21: // !
				tmp_rect.x = 2365;
				tmp_rect.w = 14;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x2D: // -
				tmp_rect.x = 3671;
				tmp_rect.w = 21;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x30: // 0
				tmp_rect.x = 2232;
				tmp_rect.w = 29;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x31: // 1
				tmp_rect.x = 2464;
				tmp_rect.w = 26;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x32: // 2
				tmp_rect.x = 2194;
				tmp_rect.w = 33;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x33: // 3
				tmp_rect.x = 2158;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x34: // 4
				tmp_rect.x = 2120;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x35: // 5
				tmp_rect.x = 2426;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x36: // 6
				tmp_rect.x = 2082;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x37: // 7
				tmp_rect.x = 2388;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x38: // 8
				tmp_rect.x = 2045;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x39: // 9
				tmp_rect.x = 2007;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3A: // : = CH veliko
				tmp_rect.x = 941;
				tmp_rect.w = 32;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3B: // ;  = ch malo
				tmp_rect.x = 3100;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3C: // <
				tmp_rect.x = 3063;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3D: // =
				tmp_rect.x = 3536;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3E: // >
				tmp_rect.x = 3025;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3F: // ?
				tmp_rect.x = 743;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x41: // A
				tmp_rect.x = 1897;
				tmp_rect.w = 40;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x42: // B
				tmp_rect.x = 1855;
				tmp_rect.w = 40;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x43: // C
				tmp_rect.x = 109;
				tmp_rect.w = 37;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x44: // D
				tmp_rect.x = 205;
				tmp_rect.w = 40;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x45: // E
				tmp_rect.x = 1815;
				tmp_rect.w = 32;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x46: // F
				tmp_rect.x = 1763;
				tmp_rect.w = 9;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x47: // G
				tmp_rect.x = 1725;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x48: // H
				tmp_rect.x = 1681;
				tmp_rect.w = 36;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x49: // I
				tmp_rect.x = 1638;
				tmp_rect.w = 33;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4A: // J
				tmp_rect.x = 708;
				tmp_rect.w = 27;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4B: // K
				tmp_rect.x = 1593;
				tmp_rect.w = 36;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4C: // L
				tmp_rect.x = 1549;
				tmp_rect.w = 36;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4D: // M
				tmp_rect.x = 1501;
				tmp_rect.w = 39;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4E: // N
				tmp_rect.x = 1459;
				tmp_rect.w = 33;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4F: // O
				tmp_rect.x = 467;
				tmp_rect.w = 39;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x50: // P
				tmp_rect.x = 1417;
				tmp_rect.w = 33;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x51: // Q = LJ veliko
				tmp_rect.x = 1356;
				tmp_rect.w = 51;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x52: // R
				tmp_rect.x = 1316;
				tmp_rect.w = 32;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x53: // S
				tmp_rect.x = 422;
				tmp_rect.w = 36;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x54: // T
				tmp_rect.x = 1274;
				tmp_rect.w = 34;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x55: // U
				tmp_rect.x = 663;
				tmp_rect.w = 36;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x56: // V
				tmp_rect.x = 1232;
				tmp_rect.w = 34;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x57: // W = NJ veliko
				tmp_rect.x = 1174;
				tmp_rect.w = 49;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x58: // X = DZ veliko
				tmp_rect.x = 66;
				tmp_rect.w = 34;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x59: // Y = Z veliko
				tmp_rect.x = 622;
				tmp_rect.w = 31;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x5B: // [ sh malo
				tmp_rect.x = 2775;
				tmp_rect.w = 39;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x5C: // /
				tmp_rect.x = 515;
				tmp_rect.w = 20;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x5D: // ] = dj malo
				tmp_rect.x = 4;
				tmp_rect.w = 32;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x61: // a
				tmp_rect.x = 2588;
				tmp_rect.w = 27;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x62: // b
				tmp_rect.x = 382;
				tmp_rect.w = 32;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x63: // c
				tmp_rect.x = 902;
				tmp_rect.w = 31;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x64: // d
				tmp_rect.x = 858;
				tmp_rect.w = 36;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x65: // e
				tmp_rect.x = 2737;
				tmp_rect.w = 29;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x66: // f
				tmp_rect.x = 154;
				tmp_rect.w = 43;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x67: // g
				tmp_rect.x = 2994;
				tmp_rect.w = 22;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x68: // h
				tmp_rect.x = 3384;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x69: // i
				tmp_rect.x = 3346;
				tmp_rect.w = 28;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6A: // j
				tmp_rect.x = 44;
				tmp_rect.w = 14;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6B: // k
				tmp_rect.x = 3306;
				tmp_rect.w = 31;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6C: // l
				tmp_rect.x = 2953;
				tmp_rect.w = 33;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6D: // m
				tmp_rect.x = 3264;
				tmp_rect.w = 34;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6E: // n
				tmp_rect.x = 3228;
				tmp_rect.w = 26;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6F: // o
				tmp_rect.x = 2697;
				tmp_rect.w = 32;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x70: // p
				tmp_rect.x = 2915;
				tmp_rect.w = 28;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x71: // q = lj malo
				tmp_rect.x = 2859;
				tmp_rect.w = 47;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x72: // r
				tmp_rect.x = 820;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x73: // s
				tmp_rect.x = 2660;
				tmp_rect.w = 29;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x74: // t
				tmp_rect.x = 2823;
				tmp_rect.w = 27;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x75: // u
				tmp_rect.x = 345;
				tmp_rect.w = 30;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x76: // v
				tmp_rect.x = 3189;
				tmp_rect.w = 29;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x77: // w  = nj malo
				tmp_rect.x = 3137;
				tmp_rect.w = 43;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x78: // x = dz malo
				tmp_rect.x = 584;
				tmp_rect.w = 28;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x79: // y = z malo
				tmp_rect.x = 2626;
				tmp_rect.w = 26;
				tmp_rect.h = 60;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
		}

	}

	return 0;
}

void cFont52::PrikaziPostepeno(std::string e_text,int p_x,int p_y,SDL_Surface* pScreen,int type,int frame)
{
  pos_x = p_x;pos_y=p_y;

  if ( frame % 2 == 0 )
   {
    if ( m_Index < e_text.size() )
     {
          m_Text += e_text[m_Index];
          m_Index++;
     }
   }
   Prikazi(m_Text, type, pos_x, pos_y,pScreen);

}
