#include "font84.h"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


cFont84::cFont84(cGameEngine *game)
{
	m_pFontList = SDL_DisplayFormatAlpha(game->UzmiMediju().r_Font84);
	m_Text = "";
    m_Index = 0;
}

cFont84::~cFont84(void)
{
    //SDL_FreeSurface(m_pFontList);
}

int cFont84::Prikazi(std::string text, int type, int pos_x, int pos_y, SDL_Surface* pScreen)
{
	

	if(!pScreen) return 1;

	SDL_Rect rect, src_rect;  
	rect.x = pos_x;
	rect.y = pos_y;
	SDL_Rect tmp_rect;
	tmp_rect.y = 0*type;

	for(int i=0; i < text.size(); i++) {

		tmp_rect.y = 0; 

		switch(text[i]) {
			case 0x20:
				rect.x += 10;
				break;
            case 0x7B: // { = SH veliko
				tmp_rect.x = 2188;
				tmp_rect.w = 78;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x7D: // } = DJ veliko
				tmp_rect.x = 1064;
				tmp_rect.w = 64;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x27: // ' = tj malo
				tmp_rect.x = 2006;
				tmp_rect.w = 50;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
            case 0x40: // @ = TJ veliko
				tmp_rect.x = 1867;
				tmp_rect.w = 63;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

            case 0x23: // # = zh malo
				tmp_rect.x = 5017;
				tmp_rect.w = 74;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

            case 0x7E: // ~ = ZH veliko
				tmp_rect.x = 3348;
				tmp_rect.w = 92;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x21: // !
				tmp_rect.x = 3713;
				tmp_rect.w = 24;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x2D: // -
				tmp_rect.x = 5521;
				tmp_rect.w = 32;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x30: // 0
				tmp_rect.x = 1693;
				tmp_rect.w = 49;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x31: // 1
				tmp_rect.x = 3617;
				tmp_rect.w = 34;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x32: // 2
				tmp_rect.x = 3560;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x33: // 3
				tmp_rect.x = 1638;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x34: // 4
				tmp_rect.x = 3504;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x35: // 5
				tmp_rect.x = 3445;
				tmp_rect.w = 51;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x36: // 6
				tmp_rect.x = 1581;
				tmp_rect.w = 51;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x37: // 7
				tmp_rect.x = 3742;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x38: // 8
				tmp_rect.x = 1525;
				tmp_rect.w = 49;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x39: // 9
				tmp_rect.x = 1472;
				tmp_rect.w = 47;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3A: // : = CH veliko
				tmp_rect.x = 2128;
				tmp_rect.w = 56;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3B: // ;  = ch malo
				tmp_rect.x = 4537;
				tmp_rect.w = 47;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3C: // <
				tmp_rect.x = 5155;
				tmp_rect.w = 47;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3D: // =
				tmp_rect.x = 5294;
				tmp_rect.w = 50;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3E: // >
				tmp_rect.x = 5100;
				tmp_rect.w = 46;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x3F: // ?
				tmp_rect.x = 1417;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x41: // A
				tmp_rect.x = 3277;
				tmp_rect.w = 64;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x42: // B
				tmp_rect.x = 3213;
				tmp_rect.w = 56;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x43: // C
				tmp_rect.x = 237;
				tmp_rect.w = 61;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x44: // D
				tmp_rect.x = 307;
				tmp_rect.w = 64;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x45: // E
				tmp_rect.x = 3152;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x46: // F
				tmp_rect.x = 3072;
				tmp_rect.w = 74;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x47: // G
				tmp_rect.x = 3016;
				tmp_rect.w = 49;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x48: // H
				tmp_rect.x = 2950;
				tmp_rect.w = 58;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x49: // I
				tmp_rect.x = 2885;
				tmp_rect.w = 57;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4A: // J
				tmp_rect.x = 1363;
				tmp_rect.w = 47;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4B: // K
				tmp_rect.x = 2819;
				tmp_rect.w = 58;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4C: // L
				tmp_rect.x = 1297;
				tmp_rect.w = 60;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4D: // M
				tmp_rect.x = 2747;
				tmp_rect.w = 39;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4E: // N
				tmp_rect.x = 2683;
				tmp_rect.w = 55;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x4F: // O
				tmp_rect.x = 696;
				tmp_rect.w = 63;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x50: // P
				tmp_rect.x = 2621;
				tmp_rect.w = 54;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x51: // Q = LJ veliko
				tmp_rect.x = 1202;
				tmp_rect.w = 86;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x52: // R
				tmp_rect.x = 2560;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x53: // S
				tmp_rect.x = 627;
				tmp_rect.w = 61;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x54: // T
				tmp_rect.x = 2496;
				tmp_rect.w = 59;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x55: // U
				tmp_rect.x = 1134;
				tmp_rect.w = 60;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x56: // V
				tmp_rect.x = 2433;
				tmp_rect.w = 57;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x57: // W = NJ veliko
				tmp_rect.x = 2344;
				tmp_rect.w = 82;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x58: // X = DZ veliko
				tmp_rect.x = 96;
				tmp_rect.w = 53;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x59: // Y = Z veliko
				tmp_rect.x = 568;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x5B: // [ sh malo
				tmp_rect.x = 4163;
				tmp_rect.w = 66;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x5C: // /
				tmp_rect.x = 768;
				tmp_rect.w = 35;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x5D: // ] = dj malo
				tmp_rect.x = 37;
				tmp_rect.w = 50;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x61: // a
				tmp_rect.x = 3937;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x62: // b
				tmp_rect.x = 1004;
				tmp_rect.w = 53;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x63: // c
				tmp_rect.x = 1806;
				tmp_rect.w = 55;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x64: // d
				tmp_rect.x = 2061;
				tmp_rect.w = 62;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x65: // e
				tmp_rect.x = 3881;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x66: // f
				tmp_rect.x = 158;
				tmp_rect.w = 73;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x67: // g
				tmp_rect.x = 4492;
				tmp_rect.w = 39;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x68: // h
				tmp_rect.x = 4957;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x69: // i
				tmp_rect.x = 4900;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6A: // j
				tmp_rect.x = 3;
				tmp_rect.w = 25;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6B: // k
				tmp_rect.x = 4842;
				tmp_rect.w = 53;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6C: // l
				tmp_rect.x = 4430;
				tmp_rect.w = 55;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6D: // m
				tmp_rect.x = 4779;
				tmp_rect.w = 57;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6E: // n
				tmp_rect.x = 4725;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x6F: // o
				tmp_rect.x = 4103;
				tmp_rect.w = 54;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x70: // p
				tmp_rect.x = 4375;
				tmp_rect.w = 46;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x71: // q = lj malo
				tmp_rect.x = 4289;
				tmp_rect.w = 79;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x72: // r
				tmp_rect.x = 1749;
				tmp_rect.w = 50;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x73: // s
				tmp_rect.x = 4049;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x74: // t
				tmp_rect.x = 4235;
				tmp_rect.w = 47;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x75: // u
				tmp_rect.x = 892;
				tmp_rect.w = 52;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
			case 0x76: // v
				tmp_rect.x = 4669;
				tmp_rect.w = 48;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x77: // w  = nj malo
				tmp_rect.x = 4590;
				tmp_rect.w = 71;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x78: // x = dz malo
				tmp_rect.x = 950;
				tmp_rect.w = 47;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;

			case 0x79: // y = z malo
				tmp_rect.x = 3996;
				tmp_rect.w = 44;
				tmp_rect.h = 100;
				tmp_rect.y = 0;
				SDL_BlitSurface( m_pFontList, &tmp_rect, pScreen, &rect);
				rect.x += tmp_rect.w;
				break;
		}

	}

	return 0;
}

void cFont84::PrikaziPostepeno(std::string e_text,int p_x,int p_y,SDL_Surface* pScreen,int type,int frame)
{
  pos_x = p_x;pos_y=p_y;

  if ( frame % 2 == 0 )
   {
    if ( m_Index < e_text.size() )
     {
          m_Text += e_text[m_Index];
          m_Index++;
     }
   }
   Prikazi(m_Text, type, pos_x, pos_y,pScreen);

}

