
#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "../core/gameengine.h"
#include "gamestate.h"
#include "glavni_meni.h"
#include "izbor.h"


cGlavniMeni cGlavniMeni::m_Glavni_Meni;

void cGlavniMeni::Init(cGameEngine* game)
{
    m_PrviIzbor = game->UzmiMediju().r_MeniDa;
    m_DrugiIzbor = game->UzmiMediju().r_MeniNe;
	//postavi prvi status
	m_Stanje = STATUS_NE;
	m_Izbor = m_DrugiIzbor;

	printf("cGlavniMeni Init\n");
}

cGlavniMeni::~cGlavniMeni(){}

void cGlavniMeni::Cleanup(cGameEngine* game)
{
	printf("cGlavniMeni cleanup\n");
	//SDL_FreeSurface(m_PrviIzbor);
	//SDL_FreeSurface(m_DrugiIzbor);
}

void cGlavniMeni::Pause()
{
	printf("cGlavniMeni Pause\n");
}

void cGlavniMeni::Resume()
{
	printf("cGlavniMeni Resume\n");
}

void cGlavniMeni::HandleEvents(cGameEngine* game)
{
	while (SDL_PollEvent(&event))
	{
		if ( event.type == SDL_QUIT )
		{
				game->Quit();
		}

        if ( event.type == SDL_KEYDOWN )
        {
				if (event.key.keysym.sym == SDLK_DOWN)
				{
                        m_Stanje++;
						if ( m_Stanje == 2 )
							m_Stanje = 0;
				}
				if (event.key.keysym.sym == SDLK_UP)
				{
                        m_Stanje--;
						if ( m_Stanje == -1 )
							m_Stanje = 1;
				}
				if (event.key.keysym.sym == SDLK_RETURN)
				{
				        if ( m_Stanje == STATUS_NE)
                            game->PopState();
						if ( m_Stanje == STATUS_DA)
                            game->Quit();
				}
		}
	}

}

void cGlavniMeni::Update(cGameEngine* game)
{
	int MENI_STATUS = m_Stanje;
	//MENI_STATUS stat = m_Stanje;

	switch (MENI_STATUS)
	{
		case STATUS_DA:
			m_Izbor = m_PrviIzbor;
			m_Stanje = STATUS_DA;
		break;
		case STATUS_NE:
			m_Izbor = m_DrugiIzbor;
			m_Stanje = STATUS_NE;
		break;
	}
}

void cGlavniMeni::Draw(cGameEngine* game)
{
	game->CrtajSliku( 192, 176 , m_Izbor, game->g_Ekran );
}
