
#include <stdio.h>

#include "SDL/SDL.h"
#include "SDL/SDL_mixer.h"
#include "../core/gameengine.h"
#include "gamestate.h"
#include "izbor.h"
#include "../gui/dugme.h"
#include "glavni_meni.h"

cIzbor cIzbor::m_Izbor;

const int          SCREEN_WIDTH = 640;
const int          SCREEN_HEIGHT = 480;
const int          SCREEN_BPP = 32;
//static const       SDL_Color BELA = {255,255,255};

void cIzbor::Init(cGameEngine* game)
{

	m_Pozadina = game->UzmiMediju().r_IzborPozadina;

    m_Poruka = new cFont52(game);

	dugme = new cDugmeIzbor(251, 47, 45, 35,game);

	m_FullScr = false;

	game->g_PrikaziPoruku = false;
}

void cIzbor::Cleanup(cGameEngine* game)
{
	printf("cIzbor Cleanup\n");
}

void cIzbor::Pause()
{
	printf("cIzbor Pause\n");
}

void cIzbor::Resume()
{
	printf("cIzbor Resume\n");
}

void cIzbor::HandleEvents(cGameEngine* game)
{
	while (SDL_PollEvent(&event))
	{
		dugme->HandleEvents(this->event, game);

		if ( event.type == SDL_QUIT )
		{
				game->Quit();
		}

        if ( event.type == SDL_KEYDOWN )
        {
				if (event.key.keysym.sym == SDLK_ESCAPE)
				{
						game->PushState( cGlavniMeni::Instance() );
				}
				if (event.key.keysym.sym == SDLK_F11)
				{
						if (m_FullScr)
						{
						game->g_Ekran = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE);
						m_FullScr = false;
						}
						else
						{
						game->g_Ekran = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_FULLSCREEN);
						m_FullScr = true;
						}
				}
		}

	}
  //}
}

void cIzbor::Update(cGameEngine* game){}

void cIzbor::Draw(cGameEngine* game)
{
    game->CrtajSliku( 0, 0, m_Pozadina, game->g_Ekran );

    if ( game->g_PrikaziPoruku )
     {
         m_Poruka->Prikazi("{tapi'i", 1, 208, 243, game->g_Ekran);
     }

     dugme->Draw(game->g_Ekran);
}

