
#include "unistd.h"
#include "SDL/SDL.h"
#include "preintro.h"
#include "intro.h"


cPreIntro cPreIntro::m_Intro;

void cPreIntro::Init(cGameEngine* game)
{
	SDL_Surface* temp = game->UzmiMediju().r_PreIntro;

	bg = SDL_DisplayFormat(temp);

	SDL_FreeSurface(temp);

	// create the fader surface like the background with alpha
	fader = SDL_CreateRGBSurface( SDL_SRCALPHA, bg->w, bg->h,
								  bg->format->BitsPerPixel,
								  bg->format->Rmask, bg->format->Gmask,
								  bg->format->Bmask, bg->format->Amask );

	// fill the fader surface with black
	SDL_FillRect (fader, NULL, SDL_MapRGB (bg->format, 0, 0, 0)) ;

	// start off opaque
	alpha = 255;

	SDL_SetAlpha(fader, SDL_SRCALPHA, alpha);

}


cPreIntro::~cPreIntro()
{

}


void cPreIntro::Cleanup(cGameEngine* game)
{
	printf("cPreIntro Cleanup\n");
}

void cPreIntro::Pause()
{
	printf("cPreIntro Pause\n");
}

void cPreIntro::Resume()
{
	printf("cPreIntro Resume\n");
}

void cPreIntro::HandleEvents(cGameEngine* game)
{
    while( SDL_PollEvent( &event ) )
    {
        if( event.type == SDL_MOUSEBUTTONDOWN )
         {
           if( event.button.button == SDL_BUTTON_LEFT )
            {
                game->ChangeState( cIntro::Instance() );
            }
         }
        //ako se korisnik odjavi
        if( event.type == SDL_QUIT )
        {
            game->Quit();
        }
    }
}

void cPreIntro::Update(cGameEngine* game)
{
    alpha-=5;

	if (alpha < 0)
	{
		alpha = 0;
	}

	SDL_SetAlpha(fader, SDL_SRCALPHA, alpha);
}

void cPreIntro::Draw(cGameEngine* game)
{
    //game->CrtajSliku( 0, 0, m_Pozadina, game->g_Ekran );
    SDL_BlitSurface(bg, NULL, game->g_Ekran, NULL);

	// no need to blit if it's transparent
	if ( alpha != 0 )
		SDL_BlitSurface(fader, NULL, game->g_Ekran, NULL);

	SDL_UpdateRect(game->g_Ekran, 0, 0, 0, 0);
}




