
#ifndef SERIJACIJA_H
#define SERIJACIJA_H

#include <iostream>
#include <string>
#include "SDL/SDL.h"
#include "gamestate.h"
#include "../core/tajmer.h"
#include "../gui/dugme_izlaz.h"
//#include "../gui/text_engine.h"
#include "../gui/font27.h"
#include "../gui/font52.h"
#include "../gui/font84.h"


class cSerijacija : public cGameState
{
public:
	void Init(cGameEngine* game);
	//void Init();
	void Cleanup(cGameEngine* game);//metode clanovi pocinju velikim slovom

	void Pause();
	void Resume();

	void HandleEvents(cGameEngine* game);
	void Update(cGameEngine* game);
	void Draw(cGameEngine* game);
	bool IspravnoPoredjano(cGameEngine* game);

	static cSerijacija* Instance() {
		return &m_Serijacija;
	}

protected:

	cSerijacija() { }

private:

	static cSerijacija   m_Serijacija;

	SDL_Surface          *m_Pozadina;//clanove sa m_VelikimSlovom
                            //odvojene reci velikim slovom

    SDL_Event             event;//samo ovo je malim slovom

    bool                 m_FullScr;
    bool                 m_KrajIgre;
    bool                 m_LevoDugmePritisnuto;
    int                  m_BrojKolizija;

    cTajmer              *m_Tajmer;
    cDugmeIzlaz          *m_DugmeIzlaz;
    //cTextEngine          *m_Poruka;
    //cTextEngine          *m_PritisniTaster;
    cFont84                *m_Poruka;
    cFont27                *m_PritisniTaster;
};

#endif

